unit fRTFtoHTML;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TConvertOptions = record
    htmlType: Integer;			      //0-XHTML, 1- HTML, 2-HTML+CSS
    Title     : Array[0..119] of Char;        //Page title
    Extension : Array[0..9] of Char;          //for example, ".html"
    FontFace : Array[0..49] of Char;         //for example, "Arial" or "Times New Roman"
    FontSize : Array[0..9] of Char;          //for example ,"10"
    preserveImages: Integer;	              //0-no, 1 - yes
    preserveFontFace: Integer;              //0-no, 1 - yes
    preserveFontSize: Integer;              //0-no, 1 - yes
    preserveFontColor: Integer;             //0-no, 1 - yes
    preserveHyperlinks: Integer;             //0-no, 1 - yes
    tableBorders: Integer;		      //0-invisble, 1 - visible
    encoding: Integer;			      {Windows_1250=0, Windows_1251=1, Windows_1252=2, Windows_1253=3,
                                   Windows_1254=4, Windows_1255=5, Windows_1256=6, Windows_1257=7,
                                   Windows_1258=8, ISO_8859_1=9,	ISO_8859_2=10,	ISO_8859_3=11,
                                   ISO_8859_4=12, ISO_8859_5=13,	ISO_8859_6=14,	ISO_8859_7=15,
                                   ISO_8859_8=16, ISO_8859_9=17,	KOI8_R=18,		UTF_8=19	}
    htmlParts: Integer;		       //0-html Complete, 1 - only between <body>..</body>
    imageFolder: Array[0..499] of Char;       //folder where image will be stored
    cssStyleName: Array[0..119] of Char; //style name, for example "ts"
    fontSizesType: Integer;		//0-normal sizes, 1 - medium sizes, 2 - big sizes, 3 - huge sizes
    imageSubfolder: Array[0..119] of Char;	//subfolder for images - only in method for strings, if ""-empty string then images will be strored in 'image_folder' without extra subfolder
    hyperlinkTarget     : Integer;              //0 - no target, 1 - target="_blank",  2 - _self, 3 - _parent, 4 - _top
    cssStartNumber      : Integer;      	//number for style name, like a .tsN (.ts1 or .ts100)
    Serial:Array[0..12] of Char;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    RtfName: TEdit;
    HtmlName: TEdit;
    memOutput: TMemo;
    Button2: TButton;
    cmbType: TComboBox;
    result: TLabel;
    rtfInput: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    cmbParts: TComboBox;
    Label5: TLabel;
    styleName: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cmbTypeChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure cmbPartsChange(Sender: TObject);
  private
    FConvertOptions: TConvertOptions;
  public
  end;

  function ConvertString(AHTML: string; ARTF: string; AOptions: TConvertOptions): pchar;
  cdecl; external 'Sautinsoft.RTFToHTML.Win32.dll' name 'ConvertString';
  function ConvertFile(RtfFile: pchar; HtmlFile: pchar; AOptions: TConvertOptions): integer;
  cdecl; external 'Sautinsoft.RTFToHTML.Win32.dll' name 'ConvertFile';
  function flushlist(): integer;
  cdecl; external 'Sautinsoft.RTFToHTML.Win32.dll' name 'flushlist';


var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  LoadLibrary('Sautinsoft.RTFToHTML.dll');
  cmbType.ItemIndex := 0;

//  struct convertOptions ct;
	FConvertOptions.cssStartNumber:=1;
	FConvertOptions.cssStyleName:='ts';
	FConvertOptions.encoding:=6;
	FConvertOptions.extension:='.htm';
	FConvertOptions.fontFace:='Verdana';
	FConvertOptions.fontSize:='10';
	FConvertOptions.htmlType:=1;
	FConvertOptions.preserveFontColor:=1;
	FConvertOptions.preserveFontFace:=1;
	FConvertOptions.preserveFontSize:=1;
	FConvertOptions.preserveImages:=1;
	FConvertOptions.preserveHyperlinks:=1;
	FConvertOptions.tableBorders:=1;
	FConvertOptions.htmlParts:=0; //only between <body>...</body>
	FConvertOptions.title:='My Page';
	FConvertOptions.imageFolder:='D:\\';
	FConvertOptions.imageSubfolder:='test.files';
	FConvertOptions.hyperlinkTarget:=0;
	FConvertOptions.Serial:='Serial number';
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  lInString: string;
  lOutString: pchar;
begin
  memOutput.Clear;
  lInString := rtfInput.Text;
  lOutString :=nil;
  StrCopy(FConvertOptions.cssStyleName, pchar(styleName.Text));
  memOutput.Lines.Text :=ConvertString(pchar(lInString), lOutString, FConvertOptions);
end;

procedure TForm1.cmbTypeChange(Sender: TObject);
begin
  case cmbType.ItemIndex of
    0: FConvertOptions.htmlType := 0; //xhtml
    1: FConvertOptions.htmlType := 1; //html
    2: FConvertOptions.htmlType := 2; //html + CSS
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  convert_code:integer;
begin
  StrCopy(FConvertOptions.cssStyleName, pchar(styleName.Text));
  convert_code:=ConvertFile(pchar(RtfName.Text), pchar(HtmlName.Text), FConvertOptions);
  flushlist(); //release memory
  case convert_code of
    -1: result.Caption:='Check serial';
    0: result.Caption:='Converting OK';
    2: result.Caption:='Not enough memory';
    3: result.Caption:='Can''t create HTML file';
    4: result.Caption:='Can''t open RTF file';
    5: result.Caption:='RTF file has zero length';
  else
       result.Caption:='Unknown Error';
  end;
end;

procedure TForm1.cmbPartsChange(Sender: TObject);
begin
  case cmbParts.ItemIndex of
    0: FConvertOptions.htmlParts:= 0; //html
    1: FConvertOptions.htmlParts:= 1; //body
  end;
end;

end.
