// SautinSoft.RtfToHtml.Win32.Java.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "SautinSoft.RtfToHtml.Win32.Java.h"
#include "javaapp_Main.h"
#include <time.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <share.h>
#include <iostream>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <string>
#include <fstream>
#include <windows.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// The one and only application object

CWinApp theApp;

using namespace std;


struct convertOptions
{
	int  htmlType;			 //0-XHTML, 1- HTML, 2-HTML+CSS
	char title[120];		 //Page title	
	char extension[10];		 //for example, ".html"
	char fontFace[50];		 //for example, "Arial" or "Times New Roman"
	char fontSize[10];		 //for example ,"10"
	int  preserveImages;	 //0-no, 1 - yes 
	int  preserveFontFace;	 //0-no, 1 - yes 
	int  preserveFontSize;	 //0-no, 1 - yes 
	int  preserveFontColor;	 //0-no, 1 - yes 
	int  preserveHyperlinks;	//0-no, 1 - yes
	int  tableBorders;		 //0-invisble, 1 - visible
	int  encoding;			 /* Windows_1250=0, Windows_1251=1, Windows_1252=2, Windows_1253=3,
								Windows_1254=4, Windows_1255=5, Windows_1256=6, Windows_1257=7,
								Windows_1258=8, ISO_8859_1=9,	ISO_8859_2=10,	ISO_8859_3=11,
								ISO_8859_4=12,	ISO_8859_5=13,	ISO_8859_6=14,	ISO_8859_7=15,
								ISO_8859_8=16,	ISO_8859_9=17,	KOI8_R=18,		UTF_8=19	*/
	int  htmlParts;			 //0-html Complete, 1 - only between <body>..</body>
	char imageFolder[500];	 //folder where image will be stored
	char cssStyleName[120];	 //style name, for example "ts"
	int  fontSizesType;		 //0-normal sizes, 1 - medium sizes, 2 - big sizes, 3 - huge sizes
	char imageSubfolder[120];//will create subfolder for storing images, if ""-empty string then images will be strored in 'image_folder' 
	int  hyperlinkTarget;	 //0 - no target, 1 - target="_blank",  2 - _self, 3 - _parent, 4 - _top
	int  cssStartNumber;	 //number for style name, like a .tsN (.ts1 or .ts100)

	char Serial[12];	 //Serial number
};

typedef int (* cfunc)(char * rtffile, char *outfolder, struct convertOptions);
cfunc ConvertFile;

typedef char * (* cfuncstring)(char * html, char * rtf, struct convertOptions);
cfuncstring ConvertString;

string GetString(char * path);
typedef int (* cfuncflushlist)(); //release memory
cfuncflushlist flushlist;
string ConvertRtf(string RTF, cfuncstring ConvertString, cfuncflushlist flushlist, jstring ser, JNIEnv * env);

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.
	}

	return nRetCode;
}


/*
 * Class:     javaapp_Main
 * Method:    ConvertFile
 * Signature: ([C[C)I
 */
JNIEXPORT jint JNICALL Java_javaapp_Main_ConvertFile
  (JNIEnv * env, jclass jc, jstring cA1, jstring cA2, jstring ser)
{
	HINSTANCE hMod=LoadLibrary(L"Sautinsoft.RTFToHTML.Win32.dll");
	if(hMod==NULL) 
	{
		return -1;
	}
	ConvertFile=(cfunc)GetProcAddress(hMod,"ConvertFile");
	if (ConvertFile==NULL)
	{
		return -1;
	}
	
	struct convertOptions ct;
	ct.cssStartNumber=1;
	strcpy(ct.cssStyleName,"ts");
	ct.encoding=9;
	strcpy(ct.extension,".htm");
	strcpy(ct.fontFace,"Verdana");
	strcpy(ct.fontSize,"10");
	ct.htmlType=1;
	ct.preserveFontColor=1;
	ct.preserveFontFace=1;
	ct.preserveFontSize=1;
	ct.preserveImages=1;
	ct.preserveHyperlinks=1;
	ct.tableBorders=1;
	ct.htmlParts=0; //only between <body>...</body>	
	strcpy(ct.title,"My Page");
	strcpy(ct.imageFolder,"D:\\");
	strcpy(ct.imageSubfolder,"test.files");
	ct.hyperlinkTarget=0;
	strcpy(ct.Serial,"Serial number");
	jboolean iscopy;
	const char * _serial = env->GetStringUTFChars( ser, &iscopy );
	strcpy(ct.Serial,_serial);
	
	const char * s1 = env->GetStringUTFChars( cA1, &iscopy );
	const char * s2 = env->GetStringUTFChars( cA2, &iscopy );
	int i;
	char str1[_MAX_PATH];
	strcpy(str1,s1);
	char str2[_MAX_PATH];
	strcpy(str2,s2);
	try
	{
		i = ConvertFile(str1,str2,ct);
	}
	catch(...)
	{
		return -1;
	}
	FreeLibrary((HMODULE)hMod);
	return i;
}

/*
 * Class:     javaapp_Main
 * Method:    CovertString
 * Signature: ([C[C)C
 */
JNIEXPORT jstring JNICALL Java_javaapp_Main_CovertString
  (JNIEnv * env, jclass jc, jstring cA1, jstring ser)
{
	HINSTANCE hMod=LoadLibrary(L"SautinSoft.RtfToHtml.Win32.dll");
	if(hMod==NULL) 
	{
		jstring err = env->NewStringUTF("error load libruary");
		return err;
	}
	string strRtf;
	string strHtml;
	ConvertString=(cfuncstring)GetProcAddress(hMod,"ConvertString");
	if (ConvertString==NULL)
	{
		jstring err = env->NewStringUTF("error load ConvertFile");
		return err;
	}
	flushlist=(cfuncflushlist)GetProcAddress(hMod,"flushlist");
	if (flushlist==NULL)
	{
		jstring err = env->NewStringUTF("error load flushlist");
		return err;
	}
	jboolean iscopy;
	const char * s1 = env->GetStringUTFChars( cA1, &iscopy );
	char str1[_MAX_PATH];
	strcpy(str1,s1);
	strRtf = GetString(str1);
	strHtml = ConvertRtf(strRtf, ConvertString, flushlist, ser, env);

	FreeLibrary((HMODULE)hMod);
	return env->NewStringUTF(strHtml.c_str());
}

JNIEXPORT jstring JNICALL Java_javaapp_Main_CovertString2
  (JNIEnv * env, jclass jc, jstring cA1, jstring ser)
{
	HINSTANCE hMod=LoadLibrary(L"SautinSoft.RtfToHtml.Win32.dll");
	if(hMod==NULL) 
	{
		jstring err = env->NewStringUTF("error load libruary");
		return err;
	}
	FreeLibrary((HMODULE)hMod);
	return env->NewStringUTF("OK");
}

string ConvertRtf(string RTF, cfuncstring ConvertString, cfuncflushlist flushlist, jstring ser, JNIEnv * env)
{
	string Html="";
	jboolean iscopy;
	struct convertOptions ct;

	
	char * strHtml=NULL;
	char * strRtf=NULL;
	int size = 0;

	size = RTF.length();

	if ((strRtf = (char *) malloc(size*sizeof(char)+1000))==NULL)
	{
		return Html;
	}
	strcpy(strRtf,RTF.c_str());

	//set conversion params
	ct.cssStartNumber=1;
	strcpy(ct.cssStyleName,"ts");
	ct.encoding=6;
	strcpy(ct.extension,".htm");
	strcpy(ct.fontFace,"Verdana");
	strcpy(ct.fontSize,"10");
	ct.htmlType=1;
	ct.preserveFontColor=1;
	ct.preserveFontFace=1;
	ct.preserveFontSize=1;
	ct.preserveImages=1;
	ct.preserveHyperlinks=1;
	ct.tableBorders=1;
	ct.htmlParts=0; //only between <body>...</body>	
	strcpy(ct.title,"My Page");
	strcpy(ct.imageFolder,"D:\\");
	strcpy(ct.imageSubfolder,"test.files");
	ct.hyperlinkTarget=0;
	const char * _serial = env->GetStringUTFChars( ser, &iscopy );
	strcpy(ct.Serial,_serial);
	
	//converting
	strHtml=(ConvertString(strRtf,strHtml,ct));

	Html.append(strHtml);

	//release memory
	flushlist();
	free(strRtf);

	return Html;
}

string GetString(char * path)
{
	int in;
	unsigned size;
	unsigned bytes;
	struct _stat st;
	char * str=NULL;
	string buffer="";
	

	if ((in=_open(path, O_RDONLY|O_TEXT))==-1)
	{
		return "";
	}
	// allocate memory
	_fstat(in,&st);
	size=st.st_size;

	if ((str = (char *) malloc(size*sizeof(char)+1000))==NULL)
	{
		close(in);
		return "";
	}
	// reading html-file
	if ((bytes=_read(in,str,size))==0)
	{
		free(str);
		close(in);
		return "";
	}	
	str[bytes]='\0';

	buffer.append(str);
	free(str);
	close(in);
	return buffer;
}